# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2008-2010 Anevia S.A. (www.anevia.com),
#    @author Raphaël Valyi <rvalyi@akretion.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from osv import fields, osv

class product_product(osv.osv):
    _inherit = "product.product"

    _columns = {
        'maintenance_template': fields.many2one('product.template',
            'Related maintenance product',
            domain=[('is_maintenance', '=', True)],
            help='Select the product template that is the maintenance service for this product.'),
        }

product_product()


class product_template(osv.osv):
    _inherit = "product.template"

    _columns = {
        "is_maintenance" : fields.boolean('Is Maintenance'),
        "maintenance_analytic_id" : fields.many2one('account.analytic.account', 'Maintenance analytic account'),
        'variants_maintained': fields.one2many('product.product', 'maintenance_template', 'Products maintained', help="These are the product variants that are covered by this maintenance template."),
    }


    def _maintenance_is_a_service(self, cr, uid, ids):
        for product in self.read(cr, uid, ids, ['is_maintenance', 'type']):
            if product['is_maintenance'] and product['type'] <> 'service':
                return False
        return True

    _constraints = [
        (_maintenance_is_a_service, "You should activate 'Is Maintenance' only on products of type 'Service'.", ['is_maintenance', 'type']),
    ]

product_template()

# Produit stockable -many2one > lien vers son template de maintenance
# c'est bien dans ce sens là qu'il faut le voir : pour un RMA, on a la machine, et on va chercher si, dans la même stock location, il y a le produit de maintenance associé.


